GNU bug report logs - #26624
26.0.50; Generalized variable `buffer-local-value' does't restore local flag

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Philipp Stephani <p.stephani2@HIDDEN>; dated Sun, 23 Apr 2017 17:14:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 26624 <at> debbugs.gnu.org:


Received: (at 26624) by debbugs.gnu.org; 17 Jun 2017 18:46:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 14:46:32 2017
Received: from localhost ([127.0.0.1]:53672 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dMIjw-0005OJ-CO
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2017 14:46:32 -0400
Received: from mail-it0-f43.google.com ([209.85.214.43]:37571)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1dMIjv-0005O6-6m
 for 26624 <at> debbugs.gnu.org; Sat, 17 Jun 2017 14:46:31 -0400
Received: by mail-it0-f43.google.com with SMTP id m47so41246266iti.0
 for <26624 <at> debbugs.gnu.org>; Sat, 17 Jun 2017 11:46:31 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=X92R3+uztBvAqLGJqosSpYh8ISGoy9rYjUIgIj8CaH0=;
 b=Mqr4/YkPFiZLXoD5g8mBErDESSZAn0jqRHCGi7Nk84veo7T9+NmLUxsQah0gGgMkqS
 zKjotrOe1ssy4r5IGdJBP7jSJFe/brnvi81kq1hbPN2e5UNP2KwGEIhL9RnqG2l7gjj9
 Jj1DwaCPxb+ntv8O/z+MebiLfYAuZZQSJb7LbrvCZl/I51RNttZlocveRMBI7rBOe2DD
 MxOwXRYrY0eHfTrvPWRPuVyqNHugfKheWs7XfOKxFsD8J084K6Mgruwc5MTtE4dmYKN0
 ljiiyLNt7peEfFrNKkPHcX+oiU7RxNPgdMJMgC04kj4Z2zi5fYFy+AQ4YLDn72d4sB/L
 oWWg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=X92R3+uztBvAqLGJqosSpYh8ISGoy9rYjUIgIj8CaH0=;
 b=Gs6RtLTOFUwL3Q8g3XAlaEbik7TTZcUbIVNRYjwJlmsHLSl7/iSsxa6/2ZEcRXu9vG
 gyCiVCV+Uyx7jhq5B6jEQLozMTYD8h7kAlvyc+en1L4008VSkS12mony5+gJ7Icb3l8K
 Y75o8EJPH4yaxZPQEtmiqrD/GQlRq1TjRaVTKvXB1tmBpwzUOU5Q6DJL6ySjJjzsKtyE
 A7PjlYfkR859j0CkD6IdwljKh9lzWogYzwRfvh2seBPG8sLVcdRZKhBVqoUfNiJ+GRV+
 /GGzMRiSDOSF9SZkQ2FkmQvogMMKYmEVap8LQXrpc2SQyeM+ISKGLCEmjXqyvvArN1Gm
 lG1Q==
X-Gm-Message-State: AKS2vOyV63g6onsT+N80fecit1ujne0zmZdZi4H636VL18oZ++7gxt4Z
 zOXSty11QqV6SVL6
X-Received: by 10.36.211.69 with SMTP id n66mr15606295itg.36.1497725185363;
 Sat, 17 Jun 2017 11:46:25 -0700 (PDT)
Received: from zony ([45.2.7.65])
 by smtp.googlemail.com with ESMTPSA id c31sm3219550ioj.53.2017.06.17.11.46.24
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 17 Jun 2017 11:46:24 -0700 (PDT)
From: npostavs@HIDDEN
To: Philipp Stephani <p.stephani2@HIDDEN>
Subject: Re: bug#26624: 26.0.50;
 Generalized variable `buffer-local-value' does't restore local flag
References: <m28tmrxd17.fsf@p>
 <CAArVCkSFpW3Sc80XKHuxC7akHPUs14+GX0A3L+eJF7vhfw7zEA@HIDDEN>
Date: Sat, 17 Jun 2017 14:48:02 -0400
In-Reply-To: <CAArVCkSFpW3Sc80XKHuxC7akHPUs14+GX0A3L+eJF7vhfw7zEA@HIDDEN>
 (Philipp Stephani's message of "Sat, 17 Jun 2017 13:10:20 +0000")
Message-ID: <8760fusb6l.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 26624
Cc: 26624 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Philipp Stephani <p.stephani2@HIDDEN> writes:

> It's possible to fix this (see attached patch), but at the expense of
> breaking other valid use cases such as (cl-incf (buffer-local-value ...)).
> Not sure whether the bug can be fixed at all without breaking other
> stuff.

I don't really understand the internals of the gv expander stuff, but
maybe we could special case the fix to cl-letf?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26624; Package emacs. Full text available.

Message received at 26624 <at> debbugs.gnu.org:


Received: (at 26624) by debbugs.gnu.org; 17 Jun 2017 13:10:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 09:10:39 2017
Received: from localhost ([127.0.0.1]:52231 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dMDUt-000294-EV
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2017 09:10:39 -0400
Received: from mail-ot0-f173.google.com ([74.125.82.173]:34941)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1dMDUr-00028r-TL
 for 26624 <at> debbugs.gnu.org; Sat, 17 Jun 2017 09:10:38 -0400
Received: by mail-ot0-f173.google.com with SMTP id u13so31022295otd.2
 for <26624 <at> debbugs.gnu.org>; Sat, 17 Jun 2017 06:10:37 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to;
 bh=ZDBfxDEQHDiYrdyaKXlX+ZDoWn+VwRRxBCv2nC7edCQ=;
 b=PB1ENeZbEXcjZ1fWvmgPx1wWdESeKfPoXn/pFGurtR93SbtztsPbyYy2j1ARNLhr//
 ND1v7RLVLKJmBZC6pBff2wym0Hmn/ki/KKCmtNMkIV9XxymwbF1Xpf8sV6j0KRK0LCu+
 0rI+y1vp0dSKiv/0d9kjUQOr7/Ur4jIAWbnp7mD8h6cQCob9Z49Pi+Jaxs2HCY90Iq6P
 fgpMvhL4etBZ5MzXKxfGSBELlBqW4oZ55H7BQU9qSRMKTsxN3t0PSgBnb8dX4CZyJZFq
 DFb+ZTukLLau9hwF92JMW0g9o3sj54ULF+rqknK7WRo2y6+9RwD7vPphCc+TiyBCKZal
 Ot9A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to;
 bh=ZDBfxDEQHDiYrdyaKXlX+ZDoWn+VwRRxBCv2nC7edCQ=;
 b=sR8+d6YbcJbdOztCKlEtVA1Xg1C1h0cmEqvc/ebhkQGvodq50vvEhb8LqAk8cp52Ez
 zXjtlanRdZ0KsPD52pNLDAsk7xUpBPwIyOQpEkn2q4MOnkFCkJhjMlaLtSTVMQSILb04
 24JvMr1laU6VgyblQOS45VAgqqA3ozd0e1NQJKX3TFXeHn59z6JvPPuOpt7nM8T+XDxe
 ywzXeHBbV4oTovGf9hugo7TsZDRmolH8ikUhlYuhCXbOXcyvrT2tgVGz/Kn8IRhHwB7p
 N4rd6sJBVUurY1WjLnhx+V0XQZNLni4yzI/XCR32kCYStVH7ZN9Fekw7jKzg2sTkt0G8
 5eRw==
X-Gm-Message-State: AKS2vOwrHg4ABjlU7vRB7vs+RajcgOXTTZOnLpzMQ8MuLNnTXSCcXg1D
 Sp1s8g8I2FvDBsVlk2jDYsIaRL2fusVk
X-Received: by 10.157.24.51 with SMTP id b48mr7969239ote.143.1497705030840;
 Sat, 17 Jun 2017 06:10:30 -0700 (PDT)
MIME-Version: 1.0
References: <m28tmrxd17.fsf@p>
In-Reply-To: <m28tmrxd17.fsf@p>
From: Philipp Stephani <p.stephani2@HIDDEN>
Date: Sat, 17 Jun 2017 13:10:20 +0000
Message-ID: <CAArVCkSFpW3Sc80XKHuxC7akHPUs14+GX0A3L+eJF7vhfw7zEA@HIDDEN>
Subject: Re: bug#26624: 26.0.50; Generalized variable `buffer-local-value'
 does't restore local flag
To: 26624 <at> debbugs.gnu.org
Content-Type: multipart/mixed; boundary="001a113e1e7e5799bb055227a00f"
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 26624
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

--001a113e1e7e5799bb055227a00f
Content-Type: multipart/alternative; boundary="001a113e1e7e5799b6055227a00d"

--001a113e1e7e5799b6055227a00d
Content-Type: text/plain; charset="UTF-8"

Philipp Stephani <p.stephani2@HIDDEN> schrieb am So., 23. Apr. 2017 um
19:14 Uhr:

>
> In *scratch*, evaluate:
>
> (defvar foo-test-var nil)
> (with-temp-buffer
>   (list (list (buffer-local-value 'foo-test-var (current-buffer))
>               (local-variable-p 'foo-test-var)
>               (local-variable-if-set-p 'foo-test-var))
>         (cl-letf (((buffer-local-value 'foo-test-var (current-buffer))
> 123))
>           (list (buffer-local-value 'foo-test-var (current-buffer))
>                 (local-variable-p 'foo-test-var)
>                 (local-variable-if-set-p 'foo-test-var)))
>         (list (buffer-local-value 'foo-test-var (current-buffer))
>               (local-variable-p 'foo-test-var)
>               (local-variable-if-set-p 'foo-test-var))))
>
> The result is:
>
> ((nil nil nil) (123 t t) (nil t t))
>
> But expected is:
>
> ((nil nil nil) (123 t t) (nil nil nil))
>
> i.e. the local flag of the variable should be reset.
>
>
It's possible to fix this (see attached patch), but at the expense of
breaking other valid use cases such as (cl-incf (buffer-local-value ...)).
Not sure whether the bug can be fixed at all without breaking other stuff.

--001a113e1e7e5799b6055227a00d
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr"><br><br><div class=3D"gmail_quote"><div dir=3D"ltr">Philip=
p Stephani &lt;<a href=3D"mailto:p.stephani2@HIDDEN">p.stephani2@HIDDEN=
om</a>&gt; schrieb am So., 23. Apr. 2017 um 19:14=C2=A0Uhr:<br></div><block=
quote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc=
 solid;padding-left:1ex"><br>
In *scratch*, evaluate:<br>
<br>
(defvar foo-test-var nil)<br>
(with-temp-buffer<br>
=C2=A0 (list (list (buffer-local-value &#39;foo-test-var (current-buffer))<=
br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-p &#39;foo=
-test-var)<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-if-set-p &=
#39;foo-test-var))<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 (cl-letf (((buffer-local-value &#39;foo-test-va=
r (current-buffer)) 123))<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (list (buffer-local-value &#39;foo-test-=
var (current-buffer))<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-p &=
#39;foo-test-var)<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-if-=
set-p &#39;foo-test-var)))<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 (list (buffer-local-value &#39;foo-test-var (cu=
rrent-buffer))<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-p &#39;foo=
-test-var)<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 (local-variable-if-set-p &=
#39;foo-test-var))))<br>
<br>
The result is:<br>
<br>
((nil nil nil) (123 t t) (nil t t))<br>
<br>
But expected is:<br>
<br>
((nil nil nil) (123 t t) (nil nil nil))<br>
<br>
i.e. the local flag of the variable should be reset.<br>
<br>
</blockquote><div><br></div><div>It&#39;s possible to fix this (see attache=
d patch), but at the expense of breaking other valid use cases such as (cl-=
incf (buffer-local-value ...)). Not sure whether the bug can be fixed at al=
l without breaking other stuff.=C2=A0</div></div></div>

--001a113e1e7e5799b6055227a00d--

--001a113e1e7e5799bb055227a00f
Content-Type: text/plain; charset="US-ASCII"; 
	name="0001-Have-cl-letf-restore-buffer-local-status-Bug-26624.txt"
Content-Disposition: attachment; 
	filename="0001-Have-cl-letf-restore-buffer-local-status-Bug-26624.txt"
Content-Transfer-Encoding: base64
Content-ID: <15cb62bd81f3568ecbb1>
X-Attachment-Id: 15cb62bd81f3568ecbb1
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--001a113e1e7e5799bb055227a00f--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26624; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Apr 2017 17:13:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Apr 23 13:13:57 2017
Received: from localhost ([127.0.0.1]:36676 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1d2L5B-0006ob-BV
	for submit <at> debbugs.gnu.org; Sun, 23 Apr 2017 13:13:57 -0400
Received: from eggs.gnu.org ([208.118.235.92]:42579)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <p.stephani2@HIDDEN>) id 1d2L5A-0006oP-Jq
 for submit <at> debbugs.gnu.org; Sun, 23 Apr 2017 13:13:56 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1d2L54-0002au-AO
 for submit <at> debbugs.gnu.org; Sun, 23 Apr 2017 13:13:51 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.1 required=5.0 tests=BAYES_50,
 FREEMAIL_ENVFROM_END_DIGIT,FREEMAIL_FROM,T_DKIM_INVALID autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:35398)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <p.stephani2@HIDDEN>)
 id 1d2L54-0002an-6T
 for submit <at> debbugs.gnu.org; Sun, 23 Apr 2017 13:13:50 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:33548)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1d2L52-0008Ao-UN
 for bug-gnu-emacs@HIDDEN; Sun, 23 Apr 2017 13:13:50 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <p.stephani2@HIDDEN>) id 1d2L51-0002aL-OW
 for bug-gnu-emacs@HIDDEN; Sun, 23 Apr 2017 13:13:48 -0400
Received: from mail-wr0-x22e.google.com ([2a00:1450:400c:c0c::22e]:34508)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <p.stephani2@HIDDEN>)
 id 1d2L51-0002aB-HA
 for bug-gnu-emacs@HIDDEN; Sun, 23 Apr 2017 13:13:47 -0400
Received: by mail-wr0-x22e.google.com with SMTP id z109so79272177wrb.1
 for <bug-gnu-emacs@HIDDEN>; Sun, 23 Apr 2017 10:13:47 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:date:message-id:mime-version;
 bh=StsOyRXo8alpcn9y5SrRCYm89uJ3bbGvV3N6+zMB/yI=;
 b=UQBzRB0lGMxyR3qjpHJ3SU0zw78RwRRPEUcdyD+A0SYasXn8wZNKGDUuYSXz4ErQvy
 AT9STDNQn5ryRvPyYHgCk2+2sffOZBcYB6/U4dULUPQdzlWCxGxyyPTp44EO+uh6gf7w
 G/JCkq1e60aMmdeoFI7ldaq/RAaUZTFqLjfq5mOMzBnsc/1vyhqpqlOn5aD368e/8iFB
 jitv/B/UeQOWxqX2sJHifeDXGc/ZukJh2TANKKDNDnpCHK5GICs7tNvNAhpi5jMNDF8E
 So3oX11j3sMzypksw6LVGZUWNFa5OKI2hWk+0Wztsy1lNgJgMHFeP9/bX6hR+ShvFHmw
 xfAg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=StsOyRXo8alpcn9y5SrRCYm89uJ3bbGvV3N6+zMB/yI=;
 b=GqdmY7k1jnIdJL5oWsoPMz94L2AkPn/jhh4QCIjqXoUOOA2zgsF8BPfUQLIR7CKO1o
 ze22F9gYimaXPtffhrVePKsncCO+00RosZMf22BeHE4kjb7QtNG5rLq2qdQndGX2BTZY
 9Ds2RlfgbD9JzoJRyisg+7Joz/5nk0GAqz7V5D2EnTyO+1Z4+uXgAN6xlg+fqtIed5OT
 bJNdvI2V6EAp/i7xUTWk4jVf6yfnokysKaDKdBTZAXlXTnSaJcgCvsPR2C+rALweUzXq
 3PaHZQ4/OzwL8Op8tOWbajP/tiICVkHK0NowwRqFnGUk8bpqX4T2X9MXqGiqBeqajC63
 II+A==
X-Gm-Message-State: AN3rC/7JeaJOkMOKn/bymFEl9Y37XA7WoGq2wZ/KQ2Ndz2gBpWWNt3n/
 NAa7BuNxGEbs6fGkwv+oSQ==
X-Received: by 10.223.148.97 with SMTP id 88mr2766428wrq.174.1492967626152;
 Sun, 23 Apr 2017 10:13:46 -0700 (PDT)
Received: from p ([2001:4c50:25f:c000:48e6:d722:5002:bf77])
 by smtp.gmail.com with ESMTPSA id k90sm9996382wmi.26.2017.04.23.10.13.44
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 23 Apr 2017 10:13:45 -0700 (PDT)
From: Philipp Stephani <p.stephani2@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 26.0.50;
 Generalized variable `buffer-local-value' does't restore local flag
Date: Sun, 23 Apr 2017 19:13:40 +0200
Message-ID: <m28tmrxd17.fsf@p>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -3.8 (---)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.8 (---)


In *scratch*, evaluate:

(defvar foo-test-var nil)
(with-temp-buffer
  (list (list (buffer-local-value 'foo-test-var (current-buffer))
              (local-variable-p 'foo-test-var)
              (local-variable-if-set-p 'foo-test-var))
        (cl-letf (((buffer-local-value 'foo-test-var (current-buffer)) 123))
          (list (buffer-local-value 'foo-test-var (current-buffer))
                (local-variable-p 'foo-test-var)
                (local-variable-if-set-p 'foo-test-var)))
        (list (buffer-local-value 'foo-test-var (current-buffer))
              (local-variable-p 'foo-test-var)
              (local-variable-if-set-p 'foo-test-var))))

The result is:

((nil nil nil) (123 t t) (nil t t))

But expected is:

((nil nil nil) (123 t t) (nil nil nil))

i.e. the local flag of the variable should be reset.



In GNU Emacs 26.0.50 (build 19, x86_64-apple-darwin16.5.0, NS appkit-1504.82 Version 10.12.4 (Build 16E195))
 of 2017-04-23 built on p
Repository revision: a1f93c1dfa53dbe007faa09ab0c6e913e86e3ffe
Windowing system distributor 'Apple', version 10.3.1504
Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Configured using:
 'configure --without-xml2 --with-modules --without-pop --with-mailutils
 --enable-checking --enable-check-lisp-object-type 'CFLAGS=-ggdb3 -O0'
 MAKEINFO=/usr/local/opt/texinfo/bin/makeinfo'

Configured features:
RSVG DBUS NOTIFY ACL GNUTLS ZLIB TOOLKIT_SCROLL_BARS NS MODULES

Important settings:
  value of $LANG: de_DE.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message subr-x puny seq byte-opt gv
bytecomp byte-compile cconv cl-loaddefs cl-lib dired dired-loaddefs
format-spec rfc822 mml easymenu mml-sec password-cache epa derived epg
epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils time-date tooltip eldoc
electric uniquify ediff-hook vc-hooks lisp-float-type mwheel term/ns-win
ns-win ucs-normalize mule-util term/common-win tool-bar dnd fontset
image regexp-opt fringe tabulated-list replace newcomment text-mode
elisp-mode lisp-mode prog-mode register page menu-bar rfn-eshadow
isearch timer select scroll-bar mouse jit-lock font-lock syntax facemenu
font-core term/tty-colors frame cl-generic cham georgian utf-8-lang
misc-lang vietnamese tibetan thai tai-viet lao korean japanese eucjp-ms
cp51932 hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese composite charscript case-table epa-hook jka-cmpr-hook
help simple abbrev obarray minibuffer cl-preloaded nadvice loaddefs
button faces cus-face macroexp files text-properties overlay sha1 md5
base64 format env code-pages mule custom widget hashtable-print-readable
backquote dbusbind kqueue cocoa ns multi-tty make-network-process emacs)

Memory information:
((conses 16 203864 9733)
 (symbols 48 19974 1)
 (miscs 40 57 190)
 (strings 32 18048 4861)
 (string-bytes 1 589547)
 (vectors 16 34976)
 (vector-slots 8 701022 3277)
 (floats 8 52 66)
 (intervals 56 199 0)
 (buffers 976 11))




Acknowledgement sent to Philipp Stephani <p.stephani2@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#26624; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 17 Jun 2017 19:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.